%define debug_package %{nil}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name:           afflib
Version:        3.7.4
Release:        1%{?dist}
Summary:        Library to support the Advanced Forensic Format

Group:          System Environment/Libraries
License:        BSD with advertising
URL:            http://www.afflib.org
Source0:        http://www.afflib.org/downloads/afflib-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch0: 	%{name}-%{version}-patch-001

BuildRequires:  libtool

BuildRequires:  curl-devel
BuildRequires:  expat-devel
# GPLv3 FOSS incompatible with BSD with advertising
BuildRequires:  fuse-devel
%if 0%{?centos} == 5 || 0%{?centos} == 6
BuildRequires:  libewf-devel == 20100226
%else
BuildRequires:  libewf-devel
%endif
# Afflib uses lzma-SDK 443
BuildRequires:  lzma-devel
BuildRequires:  ncurses-devel
BuildRequires:  libtermcap-devel
BuildRequires:  openssl-devel
BuildRequires:  python-devel
# GPLv2 FOSS incompatible with BSD with advertising
##BuildRequires:  readline-devel
#BuildRequires:  libedit-devel - good replacement for readline - not supported for now
BuildRequires:  zlib-devel
%if 0%{?rhel} == 5
BuildRequires:	python26 python26-devel
Requires:	python26
%endif


%description
AFF® is an open and extensible file format designed to store disk images and
associated metadata.
afflib is library for support of the Advanced Forensic Format (AFF).


%package -n     afftools
Summary:        Utilities for %{name}
Group:          Applications/System
Requires:       %{name} = %{version}-%{release}

%description -n afftools
The %{name}-utils package contains utilities for using %{name}.

%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       openssl-devel
Requires:       pkgconfig

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
# prevent internal lzma to be built - testing
#rm -rf lzma443

#fix spurious permissions with lzma443
find lzma443 -type f -exec chmod 0644 {} ';'
chmod 0644 lib/base64.{h,cpp}

%patch0 -p1


%build
%ifarch x86_64
%if 0%{?rhel} == 5
PYTHON=%{__python}
export PYTHON
%endif
sh bootstrap.sh 
%configure --enable-shared \
  --enable-libewf=yes \
  --enable-python=yes \
  --enable-qemu=no \
  --with-pic \
  CFLAGS=-fPIC CXXFLAGS=-fPIC
%else
%if 0%{?rhel} == 5
PYTHON=%{__python}
export PYTHON
%endif
sh bootstrap.sh
%configure --enable-shared \
  --enable-libewf=yes \
  --enable-python=yes \
  --enable-qemu=no
%endif

# Remove rpath from libtool
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

# clean unused-direct-shlib-dependencies
sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool

%ifarch x86_64
	make %{?_smp_mflags} LDFLAGS=-L/usr/lib64
%else
	make %{?_smp_mflags}
%endif


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT INSTALL="install -p"
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'



%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc AUTHORS BUGLIST.txt ChangeLog COPYING NEWS README
%doc doc/announce_2.2.txt 
%{_libdir}/*.so.*
%{_libdir}/*.a

%files -n afftools
%defattr(-,root,root,-)
%{_bindir}/af*
%{python_sitearch}/pyaff.so
%{python_sitearch}/pyaff.a
%{_mandir}/man1/affcat.1.*

%files devel
%defattr(-,root,root,-)
%doc doc/crypto_design.txt doc/crypto_doc.txt
%{_includedir}/afflib/
%{_libdir}/*.so
%{_libdir}/pkgconfig/afflib.pc

%changelog
* Sat Nov 16 2013 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.7.4-1
* Release 3.7.4-1
	Version change.
	Now uses the latest libewf that has V1 compatibility.
	
* Fri Jun 7 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.7.1-2
* Release 3.7.1-2
	Now correctly specifies the right version of libewf-devel
	
* Mon May 21 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.7.1-1
* Release 3.7.1-1
	* configure.ac: increased version number to 3.7.1
	* tools/affxml.cpp (struct page_stat_block): uint32_t long changed to uint64_t

* Sat Mar 31 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.7.0-1
* Release 3.7.0-1
	* configure.ac: increased version number to 3.7.0
	* ALL FILES: Audited for copyright.
	* COPYING: Clarified that Basis copyright only applies to 
	* Changed license from BSD with advertising to BSD without advertising.

* Fri Dec 2 2011 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.6.15-1
* Release 3.6.15-1
        * configure.ac: incorporated Greg Freemyer's patch to address some ncurses problems.
        * configure.ac: added AC_PROG_CXX
        * tools/affxml.cpp (main): removed unused bflag variable
        * lib/vnode_afd.cpp: max() is now always defined, even on windows.
        * lib/aftimer.h (aftimer::eta_time): added std:: before string
        * lib/utils.h: added virtual destructor for seginfo
        * lib/utils.h: created virtual destructore
        * lib/afflib_pages.cpp (af_get_pagesize): having af_page_size() as
          a macro was causing problems, so now there is both af_page_size
          and af_get_pagesize, both of which do the same. Please use af_get_pagesize.

* Fri Aug 5 2011 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.6.12-2
* Release 3.6.12-2
	Now includes static version of libraries

* Mon Jun 6 2011 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.6.12-1
* Release 3.6.12-1
	Just a version number change

* Wed May 4 2011 Simson Garfinkel  <simsong@alphonse-mucha.home> 3.6.11-1
* Release 3.6.11-1
	* configure.ac: increased version number to 3.6.11, overcomes recent problems.
	* configure.ac: added back libcrypto (needed on MacOS)
	* tools/affinfo.cpp (color): explicity tests for tigetstr(), putp() and tparm()
	* configure.ac: removed dependency on libcrypto (as we have libssl-dev dependency)
	* lib/Makefile.am (EXTRA_PROGRAMS): java re-added to distribution;
	  bulk_extractor.jar is now listed as an EXTRA program so it doesn't
	  always get built.

* Mon Apr 18 2011 Simson Garfinkel  <simsong@t> 3.6.10-1
- configure.ac: increased version to 3.6.10
- lib/vnode_split_raw.cpp (split_raw_increment_fname): revised
  splitraw so that it goes 000 to 999 then A00 through ZZ9 (that is,
  the first and second character are base 36, the third remains base 10)

* Mon Apr 04 2011  Simson Garfinkel  <simsong@t> 3.6.9-1
- configure.ac: incremented to version 3.6.9
- lib/aftest.cpp (bugs_test): added tests
- lib/vnode_split_raw.cpp (split_raw_identify_file): now
  returns 1 for filename.000 or filename.001 or filename.AAA or filename.aaa.
- (split_raw_close): Now only closes files that are open.
- (increment_fname) changed to vnode_split_raw_increment_fname so it
  can be externally tested.

* Mon Mar 20 2011 Simson Garfinkel  <simsong@imac3.home> 3.6.8-1
- configure.ac: increased version number to 3.6.8

* Mon Mar 18 2011 Simson Garfinkel  <simsong@Silver.local> 3.6.7-1
- configure.ac: version number incremented to 3.6.7
- lib/afflib_i.h: removed typedefs for uint and int64 and uint32_t

* Mon Mar 17 2011 Simson Garfinkel  <simsong@silver.westell.com>
- ALL OF AFFLIB: All "unsigned long" changed to uint32_t *.

* Mon Feb 16 2011 Simson Garfinkel  <simsong@imac3.home>
- lib/afflib_i.h: removed all u_int, etc. for Cstandard uint8_t, uint32_t, etc.

* Mon Jan 29 2011  Simson Garfinkel  <simsong@imac3.home>
- tools/affsegment.cpp ("C"): added extern "C" around regex.h include
- lib/utils.h: changed all u_int to "unsigned int".
- (aff): changed u_long to unsigned long
- lib/afflib.h: changed all u_int to "unsigned int" and all
  "u_char" to unsigned char to ease compiling in certain environments.

* Mon Jan 14 2011  Simson Garfinkel  <simsong@imac3.home>
- lib/afflib.cpp (af_make_badflag): changed int to unsigned int to avoid compiler warning.
- configure.ac: removed AC_MSG_NOTICE([LIBEWF: ${enable_libewf} (requires uuid-dev on Linux)])

* Mon Jan 12 2011  Simson Garfinkel  <simsong@imac3.home>
- aftimer.h (aftimer::hms): fixed plural for days.

* Mon Jan  1 2011 Simson Garfinkel  <simsong@imac3.home>
- Makefile.am (pkginclude_HEADERS): removed threaded_hash.h from package.
- lib/vnode_aff.cpp: incorporated kernel modifications from kernel mounter.

* Mon Dec 22 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- tools/affverify.cpp (hash_verify): changed aftimer to return string
- aftimer.h (class aftimer): modified to return string rather than
	deal with silly buffers.

* Mon Dec 16 2010 Simson Garfinkel  <simsong@247.sub-69-99-140.myvzw.com>
- configure.ac: removed IN_AFFLIB. I wonder what it was used for.
- configure.ac: version number increased to 3.6.6
- lib/Makefile.am (AFFLIB_SOURCES): threaded_hash.h removed from
	afflib distribution.

* Mon Dec  4 2010 Simson Garfinkel  <simsong@imac3.home>
- lib/afflib_i.h: only define ENOTSUP if it is not already defined
- configure.ac: version number increased to 3.6.5
- configure.ac: disable qemu with Msys
- configure.ac: ssl3_new in AC_CHECK_LIB changed to SSL_library_init

* Mon Nov 10 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- tools/affdiskprint.cpp: changed HAVE_EXPAT to HAVE_LIBEXPAT

* Mon Oct 25 2010 Simson Garfinkel  <simsong@imac3.home>
- tools/affxml.cpp (xml_info): was adding a NULL to data instead
	of b64size.

* Mon Oct 14 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- lib/afflib.cpp (af_open): added a warning that support for E01
	was removed.

* Mon Oct  8 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- configure.ac: increased to 3.6.3
- lib/vnode_split_raw.cpp (split_raw_get_seg): added ability to
	query AF_PAGESIZE, AF_IMAGESIZE, AF_SECTORSIZE and AF_DEVICE_SECTORS
- lib/vnode_raw.cpp (raw_get_seg): fixed AF_DEVICE_SECTORS to make
	sure that there are 8 bytes available for the data (previously was 0)
- lib/afflib_pages.cpp (af_get_page): wasn't setting *bytes if a
	page was requested and data was null. Now it does. This caused
	mis-reporting in the size of split_raw files.
- lib/vnode_split_raw.cpp (split_raw_open_internal): replaced
	fprintf with call to stderr.

* Mon Aug  9 2010 Simson Garfinkel  <simsong@m.ern.nps.edu>
- make_mingw.sh: renamed bootstrap_mingw.sh to make_mingw.sh for consistency.

* Mon Aug  1 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- configure.ac: increased version to 3.6.2
- lib/vnode_afd.cpp (afd_identify_file): added file:// logic to
	afd_identify_file from aff_identify_file
- lib/vnode_split_raw.cpp (split_raw_write_internal2): when
	storing data in AFM-files the mode set by af_open is only used for
	the AFM-file, but not for the .000 which contains the raw data. In
	case of mode 0600 for af_open,  the mode for the .000 raw-data
	file is set to 0644, which enables read-access for everyone. This
	is a possible security risk on multi-user systems. To correct
	this, mode in open() is now taken from af->openmode, and not
	hard-coded to be 0644.

* Mon Jul 29 2010 Simson Garfinkel  <simsong@imac2.home>
- win32/afflib.mak (LINK_OPTS): updated for AFFLIB3.6 naming scheme
- lib/afflib.h: added #ifdef for stdint.h
- BUGLIST.txt: removed note about afd encryption not working.


* Mon Jul 15 2010 Simson Garfinkel  <simsong@shorty.local>
- lib/vnode_afd.cpp (vnode_afd): removed AF_VNODE_NO_SEALING from vnode_afd->flags.
	(afd_add_file): ap->num_afs>0 changed to ap->num_afs>1 for copying
	over the metadata for the second file.

* Mon Jul 10 2010 Simson L. Garfinkel  <simsong@imac2.home>
- lib/afflib.h (struct af_vnode_info): changed imagesize in
	af_vnode_info structure from int64_t to uint64_t.
- tools/Makefile.am: all commands now begin aff rather than af.
- lib/vnode_ewf.cpp (ewf_vstat): removed EWF support from AFF

* Mon Jul  6 2010 Simson L. Garfinkel  <simsong@imac2.home>
- lib/vnode_aff.cpp (aff_get_seg): fixed assertion in ret.

* Mon Jun 28 2010 Simson Garfinkel  <simsong@silver-surfer.home>
- configure.ac: increased version number to 3.5.13.
- tools/Makefile.am (bin_PROGRAMS): renamed afconvert to
	affconvert because of name collission with MacOS

* Mon Jun 27 2010 Simson Garfinkel  <simsong@silver-surfer.home>
- lib/Makefile.am (EXTRA_PROGRAMS): I read on a debian complaint
	list that "aftest" and "s3" shouldn't be installed, but nobody
	thought to drop me a note explaining this or telling me how to do
	it. So after about 15 minutes with the automake manual I moved
	aftest and s3 from bin_PROGRAMS to EXTRA_PROGRAMS and now they
	shouldn't get installed. It would be really nice if those Debian
	folks to send their comments back to package authors.

* Mon Apr 25 2010 Simson L. Garfinkel  <simsong@imac2.local>
- configure.ac: version increased to 3.5.12
- Makefile.am (EXTRA_DIST): misc expat distribution removed.
- configure.ac: version increased to 3.5.11

* Mon Apr 18 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- substantial modifications to compile under mingw
- tools/afcrypto.cpp (check_file): replaced index() with strchr()
	for WIN32
- lzma443/C/Common/Alloc.cpp: removed MidAlloc(), MidFree(),
	SetLargePageSize(), BigAlloc() and BigFree() when compiling under mingw

* Mon Apr 17 2010 Simson Garfinkel  <simsong@96.sub-75-226-243.myvzw.com>
- configure.ac: patched for conditional inclusion of the win32
	directory.

* Mon Apr 14 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- debian/ directory removed at the request of the debian project.

* Mon Apr 12 2010 Ryan Mayer  <mrsolo@mayer-precision>
- lib/aftest.cpp (xmltest): now compiles without threaded_hash.h
	(simson apparently forgot to add threaded_hash.h to the subversion repository....)
- tools/afinfo.cpp (print_info): now checks to see if fwrite() doesn't
	write all the characters.
- tools/afcat.cpp (afcat): now checks to see if fwrite() doesn't
	write all the characters.
- tools/afcrypto.cpp (usage): changed -d (debug) to -D. Added -e
	option (decrypt.)

* Mon Apr 10 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- applied 03-bashism.patch, fixes a so-called bashism in a test script.
- applied 04-fix-afdiskprint.patch, fixes a grave bug which prevents
	afdiskprint from starting at all.

* Mon Apr  9 2010 Simson Garfinkel  <simsong@Silver-Surfer.local>
- tools/affuse.c (main): added explicit instructions to install fuse-devl

* Sun Apr  8 2010 Nicolas Chauvet <kwizart@fedoraproject.org> - 3.5.10-1
- Update to 3.5.10
- Remove upstreamed patch

* Tue Jan 19 2010 Nicolas Chauvet <kwizart@fedoraproject.org> - 3.5.7-1
- Update to 3.5.7

* Fri Nov 27 2009 Nicolas Chauvet <kwizart@fedoraproject.org> - 3.5.3-1
- Update to 3.5.3

* Tue Oct 27 2009 kwizart < kwizart at gmail.com > - 3.5.2-1
- Update to 3.5.2
- Remove upstreamed patch

* Thu Sep 24 2009 kwizart < kwizart at gmail.com > - 3.4.1-1
- Update to 3.4.1
- Update gcc43 (new case)
- Enable python binding.
- Avoid version-info on the python module.

* Wed Sep  2 2009 kwizart < kwizart at gmail.com > - 3.3.7-2
- Update to 3.3.7
- Update gcc44 patch

* Fri Aug 21 2009 Tomas Mraz <tmraz@redhat.com> - 3.3.6-4
- rebuilt with new openssl

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.3.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu May 21 2009 kwizart < kwizart at gmail.com > - 3.3.6-2
- Update to 3.3.6
- Add BR python-devel
- Re-introduce gcc44 patch

* Tue May 12 2009 kwizart < kwizart at gmail.com > - 3.3.5-1
- Update to 3.3.5
- Remove afflib-3.3.4-WCtype.patch

* Mon Mar  2 2009 kwizart < kwizart at gmail.com > - 3.3.4-7
- Fix for gcc44

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.3.4-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Jan 15 2009 Tomas Mraz <tmraz@redhat.com> - 3.3.4-5
- rebuild with new openssl
- call libtoolize to refresh libtool

* Fri Oct  3 2008 kwizart < kwizart at gmail.com > - 3.3.4-4
- Fix release mismatch

* Fri Oct  3 2008 kwizart < kwizart at gmail.com > - 3.3.4-3
- Update to 3.3.4

* Mon Sep 15 2008 kwizart < kwizart at gmail.com > - 3.3.3-3
- Update to 3.3.3

* Thu Sep  4 2008 kwizart < kwizart at gmail.com > - 3.3.2-2
- Update gcc43 patch

* Thu Sep  4 2008 kwizart < kwizart at gmail.com > - 3.3.2-1
- Update to 3.3.2
- Remove Requires for ewftools from afftools
- Qemu image support is disabled

* Mon Sep  1 2008 kwizart < kwizart at gmail.com > - 3.3.1-1
- Update to 3.3.1

* Tue Jul 29 2008 kwizart < kwizart at gmail.com > - 3.2.5-3
- Patch with fuzz 2

* Thu Jul 24 2008 kwizart < kwizart at gmail.com > - 3.2.5-2
- Remove nos3 patch

* Thu Jul 24 2008 kwizart < kwizart at gmail.com > - 3.2.5-1
- Update to 3.2.5

* Fri Jul  4 2008 kwizart < kwizart at gmail.com > - 3.2.3-1
- Update to 3.2.3

* Thu Jun 26 2008 kwizart < kwizart at gmail.com > - 3.2.1-4
- Explicitely disable s3

* Thu Jun 26 2008 kwizart < kwizart at gmail.com > - 3.2.1-3
- Disable s3

* Wed Jun 25 2008 kwizart < kwizart at gmail.com > - 3.2.1-2
- Fix redefinition of typedef AFFILE

* Sat Jun  7 2008 kwizart < kwizart at gmail.com > - 3.2.1-1
- Update to 3.2.1

* Wed May 21 2008 kwizart < kwizart at gmail.com > - 3.2.0-1
- Update to 3.2.0

* Tue Apr 15 2008 kwizart < kwizart at gmail.com > - 3.1.6-1
- Update to 3.1.6

* Fri Mar 21 2008 kwizart < kwizart at gmail.com > - 3.1.3-4
- Fix typo

* Wed Mar 19 2008 kwizart < kwizart at gmail.com > - 3.1.3-3
- Add missing requires with pkgconfig

* Mon Mar 17 2008 kwizart < kwizart at gmail.com > - 3.1.3-2
- Rebuild with newer libewf and enable-libewf=yes
- Add pkg-config support in afflib-devel.
- Add a patch to remove ldconfig call when building the package.
- Add libtermcap-devel

* Wed Mar 12 2008 kwizart < kwizart at gmail.com > - 3.1.3-1
- Update to 3.1.3
- Disable libewf support in afflib for now.
- Disable rpath
- Fix for gcc43 and s3

* Fri Nov 30 2007 kwizart < kwizart at gmail.com > - 3.0.4-1
- Update to 3.0.4

* Sun Nov 18 2007 kwizart < kwizart at gmail.com > - 3.0.1-1
- Update to 3.0.1

* Fri Nov  2 2007 kwizart < kwizart at gmail.com > - 2.4.0-1
- Initial package for Fedora

